package com.wissamfawaz;

import java.math.BigInteger;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) {
		int n;
		Scanner scan = new Scanner(System.in);

		System.out.println("Enter n (-1 to quit): ");
		n = scan.nextInt();
		
		while(n != -1) {
			System.out.println("Iterative solution: " + fact_iter(n));
			System.out.println("Recursive solution: " + fact_rec(n));
			System.out.println("Accurate solution: " + fact_acc(n));
			System.out.println("Enter n (-1 to quit): ");
			n = scan.nextInt();
		}
		
		scan.close();
	}

	private static long fact_iter(int n) {
		// Time complexity: O(n)
		// Space complexity: O(1)
		long output = 1L;
		for(int i=1; i <= n; i++) {
			output *= i;
		}
		
		return output;
	}
	
	private static BigInteger fact_acc(int n) {
		BigInteger output = BigInteger.ONE;
		
		for(int i=1; i<=n ; i++) {
			output = output.multiply(BigInteger.valueOf(i));
		}
		
		return output;
	}
	
	private static long fact_rec(int n) {
		// Time complexity: O(n)
		// Space complexity: O(n)
		if(n == 0) {
			return 1;
		}
		
		return n * fact_rec(n - 1);
	}
	
	
}
